/* -*- linux-c -*- */

#include <gtk/gtk.h>

#include "gtkcombobox.h"
#include "gtkcomboboxgrid.h"
#include "gtkcomboboxtext.h"
#include "gtkentryextra.h"

/**
 * this is an ugly coded demo program...
 */

void
changed_cb (GtkComboBox *cbox, gpointer data)
{
	gchar *who = (gchar *)data;

	g_print ("%s: emitted changed signal\n", who);
}

int 
main (int argc, char **argv)
{
	GtkWidget   *entry;
	GtkWidget   *window;
	GtkWidget   *label;
	GtkWidget   *cbox;
	GtkWidget   *cboxgrid;
	GtkWidget   *cboxtext;
	GtkWidget   *box;
	GtkWidget   *button;

	gtk_init (&argc, &argv);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window),
			      "GtkComboBox demo");
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
			    GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	gtk_container_border_width (GTK_CONTAINER (window), 5);
	
	box = gtk_vbox_new (FALSE, 5);
	gtk_container_add (GTK_CONTAINER (window), box);

	label = gtk_label_new (
		"This little program shows the new GtkComboBox\n"
		"and GtkComboBoxGrid in action\n");
	gtk_box_pack_start (GTK_BOX (box), label,
			    FALSE, FALSE, 0);

	entry = gtk_entry_new ();
	gtk_entry_set_text (GTK_ENTRY (entry),
			    "this is a combo box without functionality");
	gtk_widget_show (entry);
	
	cbox = gtk_combo_box_new (entry, 
				  gtk_label_new ("it is really useless"));
	gtk_box_pack_start (GTK_BOX (box), cbox,
			    FALSE, FALSE, 0);

	cboxgrid = gtk_combo_box_grid_new ();
	gtk_signal_connect (GTK_OBJECT (cboxgrid), "changed",
			    GTK_SIGNAL_FUNC (changed_cb),
			    (gpointer) "ComboBoxGrid");
	
	gtk_combo_box_grid_add_item (GTK_COMBO_BOX_GRID (cboxgrid),
				     gtk_label_new ("item 0"));
	gtk_combo_box_grid_add_item (GTK_COMBO_BOX_GRID (cboxgrid),
				     gtk_label_new ("item 1"));
	gtk_combo_box_grid_add_item (GTK_COMBO_BOX_GRID (cboxgrid),
				     gtk_label_new ( "item 2"));
	gtk_combo_box_grid_add_item (GTK_COMBO_BOX_GRID (cboxgrid),
				     gtk_label_new ("item 3"));
	gtk_combo_box_grid_add_item (GTK_COMBO_BOX_GRID (cboxgrid),
				     gtk_label_new ("item 4"));
	gtk_box_pack_start (GTK_BOX (box), cboxgrid,
			    FALSE, FALSE, 0);

	cboxtext = gtk_combo_box_text_new ();
	gtk_signal_connect (GTK_OBJECT (cboxtext), "changed",
			    GTK_SIGNAL_FUNC (changed_cb),
			    (gpointer) "ComboBoxText");

	gtk_entry_extra_set_keep_history 
		(GTK_ENTRY_EXTRA (GTK_COMBO_BOX_TEXT (cboxtext)->entry),
		 TRUE);
	gtk_entry_extra_set_autocomplete
		(GTK_ENTRY_EXTRA (GTK_COMBO_BOX_TEXT (cboxtext)->entry),
		 TRUE);
	gtk_entry_extra_set_pattern_matching
		(GTK_ENTRY_EXTRA (GTK_COMBO_BOX_TEXT (cboxtext)->entry),
		 TRUE);
	

	gtk_combo_box_text_add_item (GTK_COMBO_BOX_TEXT (cboxtext),
				     "item 0");
	gtk_combo_box_text_add_item (GTK_COMBO_BOX_TEXT (cboxtext),
				     "item 1");
	gtk_combo_box_text_add_item (GTK_COMBO_BOX_TEXT (cboxtext),
				     "item item 0");
	gtk_combo_box_text_add_item (GTK_COMBO_BOX_TEXT (cboxtext),
				     "item item 1");
	gtk_combo_box_text_add_item (GTK_COMBO_BOX_TEXT (cboxtext),
				     "blergh 1");
	gtk_box_pack_start (GTK_BOX (box), cboxtext, TRUE, TRUE, 0);
	
	button = gtk_button_new_with_label ("Quit");
	gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
				   GTK_SIGNAL_FUNC (gtk_widget_destroy),
				   GTK_OBJECT (window));
	gtk_box_pack_start (GTK_BOX (box), button,
			    TRUE, TRUE, 0);
	
	gtk_widget_show_all (window);

	gtk_main ();

	return 0;
}
